local complex = require 'complex'
local test = tonumber(...)
if test == 1 then

do
  local z = complex(3,-4)
  print(#z) --> 5
  print(getmetatable(z)) --> Complex number
  print(pcall(setmetatable, z, {}))
  --> false   cannot change a protected metatable
end
collectgarbage() --> INFO: 3-4i collected

elseif test == 2 then

local z = complex(3,4)
print(z + 2)     --> 5+4i
print(3 - 3*z)   --> -6-12i
print(z^2)       --> -7+24i
print((1):sin()) --> 0.8414709848079

elseif test == 3 then

local z1 = complex(2,5)
local z2 = complex(2,5)
local z3 = complex(4)
print(z1==z2, z1==z3)    --> true    false
print(z3==4)             --> false (Oups!)
print(z1 < z2, z1 <= z2) --> false   true
print(z1 > z3, z1 >= z3) --> true    true
print(z3 < 4, z3 <= 4)   --> false   true

elseif test == 4 then

local z1=complex(3,4)
print(z1())
print (z1'polar')
print (z1'cartesian')
print '---'
for k,v in pairs(z1) do print(k,v) end
print '---'
for z,a,b in ipairs(z1) do print(z,a,b) end

elseif test == 5 then

local complex = require 'complex'
local z1 = complex(-2,3)
local z2 = z1^2 * 3 - 2
local n = 0.6
print(z2:sin() / z1:cos()) --> -32621673488525-2.1250220319456e+14i
print(n:tan() ^ z2:tan())  --> 0.92881390431755+0.37054653033916i

elseif test == 6 then

a = complex(2,3)
a.toto = 8
print(a.toto)

end

