#define LCBC_USE_CSL 1
#include "lgencall.hpp"
#include <iostream>
using namespace std;

string Concatenate(vector<string> array, const char* separator) {
  lua::Lua lua_state;
  return lua_state.TCall<string>("return table.concat(...)", array, separator);
}

int main(int argc, char* argv[]) {
  vector<string> v;
  for(int i=0;i<argc;i++)
    v.push_back(argv[i]);
  cout << Concatenate(v, ", ");
  return 0;
}
