workspace "Compression"
  configurations { "Debug", "Release" }
  filter "configurations:Debug"
	defines "_DEBUG"
  filter "configurations:Release"
	defines { "NDEBUG" }
	optimize "full"
  filter "action:vs*"
    defines { "_CRT_SECURE_NO_WARNINGS", 
	          "_CRT_NONSTDC_NO_DEPRECATE" }
  filter {}
  
function example(name)
  project(name)
    kind "ConsoleApp"
    files(("examples/%s.c"):format(name))
    links "Zlib"
    includedirs "."
end

project "Zlib"
  kind "StaticLib"
  language "C"
  files { "*.h", "*.c" }
 
example "enough"
example "fitblk"
example "gun"
example "gzappend"
example "gzjoin"
example "gzlog"
example "zpipe"
example "zran"
