-- Instantiation d'un nouveau dissecteur
local proto = Proto("http-stat", "Statistiques du serveur Web")

-- Ajout de deux variables dans les préférences
local p = proto.prefs
p.logfile = Pref.string("Fichier Log", "", 
  "Chemin du fichier de statistiques")
local eval_enum = { { "Off", "Aucune sortie", 0 },
  { "Normal", "Normal", 1 },
  { "Verbose", "Verbeux", 2 } }
p.level = Pref.enum("Niveau", 1, "Niveau de verbosité", 
  eval_enum, true)

-- La fonction principale du dissecteur
function proto.dissector(buffer, pinfo, tree)
end

-- Enregistrement du dissecteur
local tcp_table = DissectorTable.get("tcp.port")
tcp_table:add (8080, proto)

