sqlite3=require 'lsqlite3'
local db = sqlite3.open('luavers.db')
db:exec "DROP TABLE Lua"
db:exec "CREATE TABLE Lua(version, date)"
local stmt = db:prepare "INSERT INTO Lua VALUES(?, ?)"
db:exec "BEGIN"
local vers = {
  { "4.0", "06.11.2000" },
  { "5.0", "11.04.2003" },
  { "5.1", "21.02.2006" },
  { "5.2", "16.12.2011" },
}
for _, v in ipairs(vers) do
  stmt:bind_values(v[1], v[2])
  stmt:step()
  stmt:reset()
end
db:exec 'COMMIT'
